﻿//ripped out of paperjs/examples/Animated/Lines.html
package
{
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;

	
	public class Spirographer extends Sprite
	{
		private var amount:uint = 45;
		private var count:uint = 0;
		
		public function Spirographer()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			
			for(var i:uint = 0 ; i< amount ; i++){
				var shape:Shape = new Shape();
				addChild(shape);
			}
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function enterHandler(e:Event):void
		{
			count++;
			var i:uint = 0;
			
			while(i<numChildren)
			{
				var path:Shape = getChildAt(i) as Shape;
				path.graphics.clear();
				var distPoint:Point = new Point((path.x-mouseX)/100,(path.y-mouseY)/100);
				
				var length:Number = Math.abs(Math.sin(i/2 + count / 20) * 200);
				var drawCoords:Vector.<Number> = new Vector.<Number>();
				var drawCommands:Vector.<int> = new Vector.<int>();
				drawCommands.push(2,2,2,1);
				drawCoords.push(0,0 ,(Math.cos(i*2*Math.PI/180)*length),(Math.sin(i*2*Math.PI/180)*length), (Math.cos((i+1))*length),(Math.sin((i+1))*length), 0,0);
				//color stuff
				var nR:Number = Math.cos((count-length+i)*Math.PI/180)* 127 + 128 << 32;
				var nG:Number = Math.cos((count-length+i)*Math.PI/180 + 2 * Math.PI / 3) * 127 + 128 << 16;
				var nB:Number = Math.cos((count-length+i)*Math.PI/360 + 4 * Math.PI / 3) * 127 + 128;
				path.graphics.beginFill( (nR | nG| nB),0.3);
				path.graphics.drawPath(drawCommands,drawCoords);
				path.graphics.endFill();
				path.x -= distPoint.x;
				path.y -= distPoint.y;
				this.rotation =2;
				
				i++;
			}
			
		}
	}
}